<?php
namespace Fiscal\Repositories;

class Aliquota extends \Doctrine\ORM\EntityRepository
{

    public function retornaAliquotaProduto(\Geral\Entities\Itemproduto $itemproduto, $cdimposto, $idorigdestnf = null){
        $sql = "
                SELECT A.*
                FROM TABLE(ALIQUOTA_PRODUTO(
                :P_CDIMPOSTO, :P_IDENTRSAIDOP, :P_CDEMPRESA, :P_CDARVPROD, :P_CDINCESTA, :P_CDPAISORIG, :P_SGESTADOORIG,
                :P_CDPAISDEST, :P_SGESTADODEST, :P_CDMUNICIPIO, :P_VRFIMFAIXA, :P_DTINVALID, :P_CDFILIAL, :P_NRLANCTONF,
                :P_CDGRUPOFISC, :P_CDTIPOOPER, :P_IDSISTEMA
                )) A
            ";

        $params = array(
            'P_CDIMPOSTO'   => $cdimposto,
            'P_IDENTRSAIDOP'=> $itemproduto->getLanctonf()->getIdentrsaidop(),
            'P_CDEMPRESA'   => $itemproduto->getLanctonf()->getCdempresa(),
            'P_CDARVPROD'   => $itemproduto->getCdproduto(),
            'P_CDINCESTA'   => $itemproduto->getLanctonf()->getCdinscesta(),
            'P_CDPAISDEST'  => $itemproduto->getLanctonf()->getInscesta()->getCdpais(),
            'P_SGESTADODEST'=> $itemproduto->getLanctonf()->getInscesta()->getSgestado(),
            'P_CDMUNICIPIO' => $itemproduto->getLanctonf()->getInscesta()->getCdmunicipio(),
            'P_VRFIMFAIXA'  => 1000,
            'P_DTINVALID'   => date('d/m/Y'),
            'P_CDFILIAL'    => $itemproduto->getLanctonf()->getCdfilial(),
            'P_NRLANCTONF'  => $itemproduto->getLanctonf()->getNrlanctonf(),
            'P_CDGRUPOFISC' => '',
            'P_CDTIPOOPER'  => '',
            'P_IDSISTEMA'   => ''
        );

        switch ($idorigdestnf) {
                case 'F':
                    $params['P_CDPAISORIG'] = $itemproduto->getLanctonf()->getForneced()->getEndeforneprinc()->getCdpais();
                    $params['P_SGESTADOORIG'] = $itemproduto->getLanctonf()->getForneced()->getEndeforneprinc()->getSgestado();
                    break;
                case 'L':
                    if($itemproduto->getLanctonf()->getIdentrsaidop() == 'E'){
                        $params['P_CDPAISORIG'] = $itemproduto->getLanctonf()->getFiliemit()->getEndefiliprinc()->getCdpais();
                        $params['P_SGESTADOORIG'] = $itemproduto->getLanctonf()->getFiliemit()->getEndefiliprinc()->getSgestado();
                        break;
                    }
                    $params['P_CDPAISORIG'] = $itemproduto->getLanctonf()->getFilirece()->getEndefiliprinc()->getCdpais();
                    $params['P_SGESTADOORIG'] = $itemproduto->getLanctonf()->getFilirece()->getEndefiliprinc()->getSgestado();
                    break;
                case 'C':
                    $params['P_CDPAISORIG'] = $itemproduto->getLanctonf()->getCliente()->getEndeclieprinc()->getCdpais();
                    $params['P_SGESTADOORIG'] = $itemproduto->getLanctonf()->getCliente()->getEndeclieprinc()->getSgestado();
                    break;
                default:
                    $params['P_CDPAISORIG'] = $itemproduto->getLanctonf()->getForneced()->getEndeforneprinc()->getCdpais();
                    $params['P_SGESTADOORIG'] = $itemproduto->getLanctonf()->getForneced()->getEndeforneprinc()->getSgestado();
                    break;
            }

        $result = self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        return count($result) > 0 ? $result : false;
    }
}