IF EXISTS (SELECT *
                   FROM SYSOBJECTS O, SYSUSERS U
                 WHERE O.NAME = 'CALCULA_EMB_LIST_SERV' AND
                             TYPE = 'P' AND
                             U.UID = O.UID AND
                             U.NAME = USER
                )
DROP PROCEDURE CALCULA_EMB_LIST_SERV
GO


CREATE PROCEDURE CALCULA_EMB_LIST_SERV
(
   @P_DTCARDAPIOINI DATETIME,
   @P_DTCARDAPIOFIN DATETIME,
   @P_NRLISTA_SERV VARCHAR(10),
   @P_SUBSTITUI_DIST_ATUAL VARCHAR(1)
)
AS
   DECLARE @V_CDFILIAL VARCHAR(4);
   DECLARE @V_CDSERVFILI VARCHAR(5);
   DECLARE @V_CDCLIENTE VARCHAR(21);
   DECLARE @V_CDDESTFILI VARCHAR(3);
   DECLARE @V_RETORNO VARCHAR(200);
   DECLARE @V_DTCARDAPIO DATETIME;
   
   DECLARE C_SERVICOS CURSOR LOCAL
   FOR
   SELECT S.CDFILIAL, S.CDSERVFILI, D.CDCLIENTE, D.CDDESTFILI
     FROM LISTA L
          INNER JOIN SERVICO S ON S.CDFILIAL = SUBSTRING(L.CDLISTA, 1, 4) AND
                                  S.CDSERVFILI = SUBSTRING(L.CDLISTA, 6, 5) AND
                                  S.IDSERVTRAN = 'S'
          LEFT JOIN DESTSRVCLI D ON D.CDFILIAL = SUBSTRING(L.CDLISTA, 1, 4) AND
                                    D.CDSERVFILI = SUBSTRING(L.CDLISTA, 6, 5)
    WHERE L.NRLISTA = @P_NRLISTA_SERV;
      
BEGIN

   SET @V_DTCARDAPIO = @P_DTCARDAPIOINI;
   
   WHILE @V_DTCARDAPIO <= @P_DTCARDAPIOFIN BEGIN
      
      OPEN C_SERVICOS;
      
      FETCH NEXT FROM C_SERVICOS
      INTO @V_CDFILIAL, @V_CDSERVFILI, @V_CDCLIENTE, @V_CDDESTFILI;
      
      /*Aplica a procedure de distribuio do servio para cada servio pertencente  lista*/
      WHILE (@@FETCH_STATUS = 0) BEGIN       
         
         EXEC CALCULA_EMB_SERV @V_CDFILIAL, @V_CDSERVFILI, @V_DTCARDAPIO, @V_CDCLIENTE, @V_CDDESTFILI, @P_SUBSTITUI_DIST_ATUAL, @V_RETORNO;
         
         FETCH NEXT FROM C_SERVICOS
         INTO @V_CDFILIAL, @V_CDSERVFILI, @V_CDCLIENTE, @V_CDDESTFILI;         
      END;
      
      CLOSE C_SERVICOS;
      
      SET @V_DTCARDAPIO = @V_DTCARDAPIO + 1;
   END;
   
END;
GO

-- VERSAO --
BEGIN EXEC ATUVEROBJ 'CALCULA_EMB_LIST_SERV','5.75.000'; END;
GO